unit RegConfig;

interface
uses
  Controls;

procedure SaveCtrl(C: TControl; ExceptionOnUnknownControl: boolean=true);
procedure LoadCtrl(C: TControl; ExceptionOnUnknownControl: boolean=true);

implementation
uses
  SysUtils, Registry, ComCtrls, StdCtrls, Forms, WerControl;

procedure SaveCtrl(C: TControl; ExceptionOnUnknownControl: boolean=true);
var
  R: TRegistry;
  I: Integer;
begin
  if C is TWinControl then
    for I:=0 to TWinControl(C).ControlCount-1 do
      SaveCtrl(TWinControl(C).Controls[I],False);
  R:=TRegistry.Create;
  R.OpenKey('\Software\WER\'+Application.Title+'\',True);
  if C is TCheckBox then
    R.WriteBool(C.Name,TCheckBox(C).Checked)
  else
  if C is TEdit then
    R.WriteString(C.Name,TEdit(C).Text)
  else
  if C is TWerSpinEdit then
    R.WriteInteger(C.Name,TWerSpinEdit(C).IntValue)
  else
    if ExceptionOnUnknownControl and not (C is TWinControl) then
      raise Exception.Create('Unknown control type for control '+C.Name);
  R.Free;
end;

procedure LoadCtrl(C: TControl; ExceptionOnUnknownControl: boolean=true);
var
  R: TRegistry;
  I: Integer;
begin
  if C is TWinControl then
    for I:=0 to TWinControl(C).ControlCount-1 do
      LoadCtrl(TWinControl(C).Controls[I],False);
  R:=TRegistry.Create;
  R.OpenKey('\Software\WER\'+Application.Title+'\',True);
  if not R.ValueExists(C.Name) then
    // leave control as is
  else
  if C is TCheckBox then
    begin
    TCheckBox(C).Checked:=R.ReadBool(C.Name);
    if Assigned(TCheckBox(C).OnClick) then
      TCheckBox(C).OnClick(C);
    end
  else
  if C is TEdit then
    TEdit(C).Text:=R.ReadString(C.Name)
  else
  if C is TWerSpinEdit then
    TWerSpinEdit(C).IntValue:=R.ReadInteger(C.Name)
  else
    if ExceptionOnUnknownControl then
      raise Exception.Create('Unknown control type for control '+C.Name);
  R.Free;
end;

end.
